--
-- Plugin Quick-Loader for Lord of The Rings Online
--
-- by Bosko
--
-- http://www.lotrointerface.com/portal.php?&uid=4117
--

import "Turbine"

function LoadAllPlugins()
    Turbine.PluginManager.RefreshAvailablePlugins();
    local pluginsA = Turbine.PluginManager.GetAvailablePlugins();
    local pluginsL = Turbine.PluginManager.GetLoadedPlugins();
    for i, p1 in pairs(pluginsA) do
        if p1.Name ~= "QuickLoad" then
            local fLoaded = false;
            for j, p2 in pairs(pluginsL) do
                if p1.Name == p2.Name then
                    fLoaded = true;
                end
            end
            
            if fLoaded then
                Turbine.Shell.WriteLine(string.format("%s (%s) by %s is already loaded.", 
                    p1.Name, p1.Version, p1.Author));
            else
                Turbine.Shell.WriteLine(string.format("Loading %s (%s) by %s...", 
                    p1.Name, p1.Version, p1.Author));
                Turbine.PluginManager.LoadPlugin(p1.Name);
            end
        end
    end
end


LoadAllPlugins();

--==============================================================================
-- QuickLoadCommand
--==============================================================================
QuickLoadCommand = Turbine.ShellCommand();

--------------------------------------------------------------------------------
function QuickLoadCommand:GetHelp()
    return "QuickLoad by Bosko. Loads all plugins in one shot.";
end

--------------------------------------------------------------------------------
function QuickLoadCommand:GetShortHelp()
    return "Quick-load all plugins. Commands: help";
end

--------------------------------------------------------------------------------
function QuickLoadCommand:Execute(command, arguments)
    if arguments == "" then
        LoadAllPlugins();
    elseif arguments == "help" then
        -- Help
        Turbine.Shell.WriteLine(QuickLoadCommand:GetHelp());
    end
end

--------------------------------------------------------------------------------
-- Add the command
Turbine.Shell.AddCommand("qload;QuickLoad", QuickLoadCommand);
